package net.cannonade.CodeLabAfter;

import java.io.IOException;
import java.util.List;

import android.location.Address;
import android.location.Geocoder;
import android.os.AsyncTask;
import android.os.Bundle;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;

public class CodeLabDetail extends MapActivity {
	
	Geocoder mGeo;
	MapView mMapView;
	
	private void setLocation (GeoPoint point)
	{
		// set the map location
		MapController mc = mMapView.getController();
        mc.setZoom(5); 
        mc.setCenter(point);	
	}
	
	
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
   
        setContentView(R.layout.detail);
        
        mMapView = (MapView) findViewById(R.id.mapview);
       
        mMapView.setBuiltInZoomControls(true);
        mMapView.setClickable(true);
        mMapView.setSatellite(true);
    
        MapController mc = mMapView.getController();
        mc.setZoom(10); 
        mc.setCenter(new GeoPoint(0, 0));
        
        Bundle extras = getIntent().getExtras(); 
        
        String name = extras.getString("net.cannonade.name");
        mGeo = new Geocoder (this.getApplicationContext());
        new GeocodeTask().execute(name);
    }
    
    private GeoPoint blockingGeocodeCall (String name)
    {
    	List	<Address> addressList;
    	try {
			addressList = mGeo.getFromLocationName(name, 1);
    	 } catch (IOException e) {
			// due to a bug in the emulator ... can't demo this
			// so lets just hardcode the location
			return (new GeoPoint(-34 * 1000000,151 * 1000000));
    	 }
		
    	 if (addressList.size() > 0)
    	 {
    		 Address address = addressList.get(0);
    		 return (new GeoPoint((int)address.getLatitude() * 1000000,(int)address.getLongitude() * 1000000));
    	 }
		
    	 return (new GeoPoint(-34 * 1000000,151 * 1000000));
    }
    
    private class GeocodeTask extends AsyncTask<String, Void, GeoPoint> {
	     protected GeoPoint doInBackground(String... name) {
	    	 return blockingGeocodeCall (name[0]);
	     }
	     protected void onPostExecute(GeoPoint result) {
	         setLocation(result);
	     }
	 }

	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}

}

